--
-- Mutilate
-- 

--
-- 20 energy every 2 seconds
--

--
-- Deadly Poison dot = 3
--

-- Our base array
Mutilate = {}

-- Mutilate variables NOT SAVED
Mutilate.versionNumber = 1.05
Mutilate.currentTarget = ""
Mutilate.lastTarget = ""


-- Define list of terms that need translation.
function FM_GetSpellNameById(spellId)
	if (spellId == nil) then
		return nil
	end
		local spellName, rank, _, _, _, _, _, _, _ = GetSpellInfo(spellId)
	if rank==nil then
	return spellName
	elseif string.len(rank)>1 then
		return spellName.."("..rank..")"
	end
	return spellName
end

Mutilate.L = {
	["Garrote"]             = "Garrote",
	["Slice and Dice"]      = "Slice and Dice",
	["Hunger for Blood"]    = "Hunger For Blood",
	["Mutilate"]            = "Mutilate",
	["Envenom"]             = "Envenom",
	["Rupture"]             = "Rupture",
	["Cold Blood"]          = "Cold Blood",
	["Tricks of the Trade"] = "Tricks of the Trade",
	["Vanish"]              = "Vanish",
}
	
local language = GetLocale();

Mutilate.L["Garrote"]             = FM_GetSpellNameById(48676)
Mutilate.L["Slice and Dice"]      = FM_GetSpellNameById(6774)
Mutilate.L["Hunger for Blood"]    = FM_GetSpellNameById(51662)
Mutilate.L["Mutilate"]            = FM_GetSpellNameById(48666)
Mutilate.L["Envenom"]             = FM_GetSpellNameById(57993)
Mutilate.L["Rupture"]             = FM_GetSpellNameById(48672)
Mutilate.L["Cold Blood"]          = FM_GetSpellNameById(14177)
Mutilate.L["Tricks of the Trade"] = FM_GetSpellNameById(57934)
Mutilate.L["Vanish"]              = FM_GetSpellNameById(26889)



Mutilate.timeSinceLastUpdate = 0
Mutilate.DeadlyPoisionTick = 0

Mutilate.playerName = UnitName("player")
Mutilate.spellHaste = GetCombatRatingBonus(20)



Mutilate.textureList = {
  ["last"] = nil,
  ["current"] = nil,
  ["next"] = nil,
  ["misc"] = nil,
  ["int"] = nil,
  }


-- Our sneaky frame to watch for events ... checks Mutilate.events[] for the function.  Passes all args.
Mutilate.eventFrame = CreateFrame("Frame")
Mutilate.eventFrame:SetScript("OnEvent", function(this, event, ...)
  Mutilate.events[event](...)
end)

Mutilate.eventFrame:RegisterEvent("ADDON_LOADED")
Mutilate.eventFrame:RegisterEvent("PLAYER_LOGIN")
Mutilate.eventFrame:RegisterEvent("PLAYER_ALIVE")
Mutilate.eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")


-- Define our Event Handlers here
Mutilate.events = {}

function Mutilate.events.PLAYER_ALIVE()
	--SendChatMessage("Mutilate.events.PLAYER_ALIVE()",  "SAY", GetDefaultLanguage("player"));
	Mutilate.eventFrame:UnregisterEvent("PLAYER_ALIVE")
end

function Mutilate.events.PLAYER_LOGIN()
	--SendChatMessage("Mutilate.events.PLAYER_LOGIN()",  "SAY", GetDefaultLanguage("player"));
	Mutilate.playerName = UnitName("player");
end

function Mutilate.events.ADDON_LOADED(addon)

	if addon ~= "Mutilate" then 
		return 
	end
	
	local _,playerClass = UnitClass("player")
	if playerClass ~= "ROGUE" then
		Mutilate.eventFrame:UnregisterEvent("PLAYER_ALIVE")
		Mutilate.eventFrame:UnregisterEvent("ADDON_LOADED")
		Mutilate.eventFrame:UnregisterEvent("PLAYER_LOGIN")
		Mutilate.eventFrame:UnregisterEvent("PLAYER_TARGET_CHANGED")
		return 
	end
	
	-- Default saved variables
	if not Mutilatedb then
		Mutilatedb = {} -- fresh start
	end
	if not Mutilatedb.scale then Mutilatedb.scale = 1 end
	if Mutilatedb.locked == nil then Mutilatedb.locked = false end
	if not Mutilatedb.x then Mutilatedb.x = 100 end
	if not Mutilatedb.y then Mutilatedb.y = 100 end
	if not Mutilatedb.SuggestVanish then Mutilatedb.SuggestVanish = false end
	if not Mutilatedb.MasterPoison then Mutilatedb.MasterPoison = true end
	if not Mutilatedb.SuggestRupture then Mutilatedb.SuggsetRupture = false end
	if Mutilatedb.range == nil then Mutilatedb.range = true end

	-- Create GUI
	Mutilate:CreateGUI()
	Mutilate.displayFrame:SetScale(Mutilatedb.scale)


	-- Create Options Frame
	Mutilate:CreateOptionFrame()
	if Mutilatedb.locked then
		Mutilate.displayFrame:SetScript("OnMouseDown", nil)
		Mutilate.displayFrame:SetScript("OnMouseUp", nil)
		Mutilate.displayFrame:SetScript("OnDragStop", nil)
		Mutilate.displayFrame:SetBackdropColor(0, 0, 0, 0)
		Mutilate.displayFrame:EnableMouse(false)
	else
		Mutilate.displayFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		Mutilate.displayFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		Mutilate.displayFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		Mutilate.displayFrame:SetBackdropColor(0, 0, 0, .4)
		Mutilate.displayFrame:EnableMouse(true)
	end

	-- Register for Slash Commands
	SlashCmdList["Mutilate"] = Mutilate.Options
	SLASH_Mutilate1 = "/Mutilate"
	SLASH_Mutilate2 = "/mut"

	-- Register for Function Events
	Mutilate.eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Mutilate.eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")



	--SendChatMessage("Mutilate.events.ADDON_LOADED(addon)",  "SAY", GetDefaultLanguage("player"));

end

function Mutilate.events.COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	--SendChatMessage("Mutilate.events.COMBAT_LOG_EVENT_UNFILTERED",  "SAY", GetDefaultLanguage("player"));
	
	if UnitName("target") == nil or UnitIsFriend("player","target") ~= nil or UnitHealth("target") == 0 then
		Mutilate.displayFrame_last:Hide()
		Mutilate.displayFrame_current:Hide()
		Mutilate.displayFrame_next:Hide()
		Mutilate.displayFrame_misc:Hide()
		Mutilate.displayFrame_int:Hide()
	else
		Mutilate.displayFrame_last:Show()
		Mutilate.displayFrame_current:Show()
		Mutilate.displayFrame_next:Show()
		Mutilate.displayFrame_misc:Show()
		Mutilate.displayFrame_int:Show()
		Mutilate:DecideSpells()
	end

	
end

function Mutilate.events.COMBAT_RATING_UPDATE(unit)
	--SendChatMessage("Mutilate.events.COMBAT_RATING_UPDATE(unit)",  "SAY", GetDefaultLanguage("player"));

end

function Mutilate.events.PLAYER_TARGET_CHANGED(...)
	--SendChatMessage("Mutilate.events.PLAYER_TARGET_CHANGED(...)",  "SAY", GetDefaultLanguage("player"));
	
	-- target changed, set last target, update current target, will be nil if no target
	Mutilate.lastTarget = Mutilate.currentTarget
	Mutilate.currentTarget = UnitGUID("target")
	
	if UnitName("target") == nil or UnitIsFriend("player","target") ~= nil or UnitHealth("target") == 0 then
		Mutilate.displayFrame_last:Hide()
		Mutilate.displayFrame_current:Hide()
		Mutilate.displayFrame_next:Hide()
		Mutilate.displayFrame_misc:Hide()
		Mutilate.displayFrame_int:Hide()
	else
		Mutilate.displayFrame_last:Show()
		Mutilate.displayFrame_current:Show()
		Mutilate.displayFrame_next:Show()
		Mutilate.displayFrame_misc:Show()
		Mutilate.displayFrame_int:Show()
		Mutilate:DecideSpells()
	end
end



-- End Event Handlers


function Mutilate:CreateGUI()

  local displayFrame = CreateFrame("Frame","MutilateDisplayFrame",UIParent)
  displayFrame:SetFrameStrata("BACKGROUND")
  displayFrame:SetWidth(250)
  displayFrame:SetHeight(90)
  displayFrame:SetBackdrop({
          bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 32,
  			})
  displayFrame:SetBackdropColor(0, 0, 0, .4)
  displayFrame:EnableMouse(true)
  displayFrame:SetMovable(true)
  displayFrame:SetClampedToScreen(true)
  displayFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
  displayFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
  displayFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)

  displayFrame:SetPoint("CENTER",-200,-200)

  local displayFrame_last = CreateFrame("Frame","$parent_last", MutilateDisplayFrame)
  local displayFrame_current = CreateFrame("Frame","$parent_current", MutilateDisplayFrame)
  local displayFrame_next = CreateFrame("Frame","$parent_next", MutilateDisplayFrame)
  local displayFrame_misc = CreateFrame("Frame","$parent_misc", MutilateDisplayFrame)
  local displayFrame_int = CreateFrame("Frame","$parent_int", MutilateDisplayFrame)

  displayFrame_last:SetWidth(45)
  displayFrame_current:SetWidth(70)
  displayFrame_next:SetWidth(45)
  displayFrame_misc:SetWidth(45)
  displayFrame_int:SetWidth(45)

  displayFrame_last:SetHeight(45)
  displayFrame_current:SetHeight(70)
  displayFrame_next:SetHeight(45)
  displayFrame_misc:SetHeight(45)
  displayFrame_int:SetHeight(45)


  displayFrame_last:SetPoint("TOPLEFT", 0, -45)
  displayFrame_current:SetPoint("TOPLEFT", 90, -10)
  displayFrame_next:SetPoint("TOPLEFT", 200, -45)
  displayFrame_misc:SetPoint("TOPLEFT", 0, 0)
  displayFrame_int:SetPoint("TOPLEFT", 200, 0)


  local t = displayFrame_last:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:SetAllPoints(displayFrame_last)
  t:SetAlpha(.8)
  displayFrame_last.texture = t
  Mutilate.textureList["last"] = t

  t = displayFrame_current:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:ClearAllPoints()
  t:SetAllPoints(displayFrame_current)
  displayFrame_current.texture = t
  Mutilate.textureList["current"] = t

  t = displayFrame_misc:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:SetAllPoints(displayFrame_misc)
  t:SetAlpha(.8)
  displayFrame_misc.texture = t
  Mutilate.textureList["misc"] = t

  t = displayFrame_int:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:SetAllPoints(displayFrame_int)
  t:SetAlpha(.8)
  displayFrame_int.texture = t
  Mutilate.textureList["int"] = t

  t = displayFrame_next:CreateTexture(nil,"BACKGROUND")
  t:SetTexture(nil)
  t:SetAllPoints(displayFrame_next)
  t:SetAlpha(.8)
  displayFrame_next.texture = t
  Mutilate.textureList["next"] = t


  displayFrame:SetScript("OnUpdate", function(this, elapsed)
    Mutilate:OnUpdate(elapsed)
  end)

  local cooldownFrame = CreateFrame("Cooldown","$parent_cooldown", MutilateDisplayFrame_current)
  cooldownFrame:SetHeight(70)
  cooldownFrame:SetWidth(70)
  cooldownFrame:ClearAllPoints()
  cooldownFrame:SetPoint("CENTER", displayFrame_current, "CENTER", 0, 0)
  
  Mutilate.displayFrame = displayFrame
  Mutilate.displayFrame_last = displayFrame_last
  Mutilate.displayFrame_current = displayFrame_current
  Mutilate.displayFrame_next = displayFrame_next
  Mutilate.displayFrame_misc =  displayFrame_misc
  Mutilate.displayFrame_int =  displayFrame_int
  Mutilate.cooldownFrame = cooldownFrame

end

function Mutilate:OnUpdate(elapsed)

	Mutilate.timeSinceLastUpdate = Mutilate.timeSinceLastUpdate + elapsed;
	

	--
	-- Deadly Poison IX Ticks
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Deadly Poison IX")
	if name == nil then
		Mutilate.DeadlyPoisionTick = 0;
	elseif name ~= nil and isMine ~= "player" then
		Mutilate.DeadlyPoisionTick = 0;
	elseif name ~= nil and isMine == "player" then
		Mutilate.DeadlyPoisionTick = Mutilate.DeadlyPoisionTick + elapsed;

		if(Mutilate.DeadlyPoisionTick >= 3.0) then
			--SendChatMessage("Deadly Poison IX Tick",  "SAY", GetDefaultLanguage("player"));
			Mutilate.DeadlyPoisionTick = 0;
		end
	end


--	if (Mutilate.timeSinceLastUpdate >= 1) then
		Mutilate:DecideSpells()
--	end

end

function Mutilate:DecideSpells()

	Mutilate.timeSinceLastUpdate = 0;

	local guid = UnitGUID("target")
	local puid = UnitGUID("player")
	
	if  UnitName("target") == nil or UnitIsFriend("player","target") ~= nil or UnitHealth("target") == 0 then
		return -- ignore the dead and friendly
	end

	if guid == nil then
		Mutilate.textureList["last"]:SetTexture(nil)
		Mutilate.textureList["current"]:SetTexture(nil)
		Mutilate.textureList["next"]:SetTexture(nil)
		Mutilate.textureList["misc"]:SetTexture(nil)
		Mutilate.textureList["int"]:SetTexture(nil)
		return
	end

	local energy = UnitPower("player")
	local cp = GetComboPoints("player")
	local currentTime = GetTime()

	local spell = ""
	local nextspell = ""
	local aoespell = ""
	local miscspell = ""
	local intspell = ""
	
	local garrote = 0
	local slice_and_dice = 0
	local hunger_for_blood = 0
	local rupture = 0
	local cold_blood = 0
	local tott = 0
	local deadly_posion = 0
	local vanish = 0
	local overkill = 0
	
	local bleeds = 0

	-- spell id informations
	--local spellID = (GetSpellLink("Eviscerate") or ""):match("Hspell:(%d+)")
	--spellID = spellID and tonumber(spellID) 
	
	--
	-- Rotation borrowed from :
	-- http://elitistjerks.com/f78/t37183-pocket_guide_wotlk_updated_3_1_a/
	--

	--
	-- Bleeds
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Garrote")
	if name ~= nil then
		bleeds = 1
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Rupture")
	if name ~= nil then
		bleeds = 1
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Deep Wounds")
	if name ~= nil then
		bleeds = 1
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Rend")
	if name ~= nil then
		bleeds = 1
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Trauma")
	if name ~= nil then
		bleeds = 1
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Mangle")
	if name ~= nil then
		bleeds = 1
	end

	--
	-- Garrote
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Garrote")

	currentTime = GetTime()
	if name ~= nil and isMine == "player" then
		garrote = expirationTime - currentTime
	end	
	
	--
	-- Slice and Dice
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff("player", "Slice and Dice")

	currentTime = GetTime()
	if name ~= nil then
		slice_and_dice = expirationTime - currentTime
	end
	
	--
	-- Overkill
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff("player", "Overkill")

	currentTime = GetTime()
	if name ~= nil then
		overkill = expirationTime - currentTime
	end
	
	--
	-- Hunger for Blood
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitBuff("player", "Hunger for Blood")

	currentTime = GetTime()
	if name ~= nil then
		hunger_for_blood = expirationTime - currentTime
	end
	
	--
	-- Ruture
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Rupture")
	currentTime = GetTime()
	if name ~= nil and isMine == "player" then
		rupture = expirationTime - currentTime
	end	


	--
	-- Deadly Poison IX
	--
	local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable = UnitDebuff("target", "Deadly Poison IX")
	if name ~= nil and count >= 4 and isMine == "player" then
		deadly_posion = 1
	end

	
	--
	-- Cold Blood
	--
	local start, duration, enabled = GetSpellCooldown(Mutilate.L["Cold Blood"]);
	if duration ~= nil then 
		cold_blood = duration + start - currentTime
	else
		cold_blood = 60
	end	
	
	--
	-- Tricks of the Trade
	--
	local start, duration, enabled = GetSpellCooldown(Mutilate.L["Tricks of the Trade"]);
	if duration ~= nil then 
		tott = duration + start - currentTime
	else
		tott = 60
	end	
	
	--
	-- Vanish
	--
	local start, duration, enabled = GetSpellCooldown(Mutilate.L["Vanish"]);
	if duration ~= nil then 
		vanish = duration + start - currentTime
	else
		Vanish = 60
	end	
	
	--
	-- Ensure that there is a bleed (ie. Rupture, Deep Wounds, Rend) on the target.
	--

	if UnitAura("player", "Stealth") ~= nil then
		if (energy >= 50) then
			spell = Mutilate.L["Garrote"]
		else
			nextspell = Mutilate.L["Garrote"];
		end
	elseif (hunger_for_blood <= 5.0) then
		if (bleeds == 1) then
			if (energy >= 15) then
				spell = Mutilate.L["Hunger for Blood"];
			else
				nextspell = Mutilate.L["Hunger for Blood"];
			end
		else
			if (cp == 0) then
				if (energy >= 55) then
					spell = Mutilate.L["Mutilate"];
					nextspell = Mutilate.L["Rupture"];
				else
					nextspell = Mutilate.L["Mutilate"];
				end
			else
				if (energy >= 25) then
					spell = Mutilate.L["Rupture"];
					nextspell = Mutilate.L["Hunger for Blood"];
				else
					nextspell = Mutilate.L["Rupture"];
				end 
			end
		end
	elseif (cp >= 1) and (slice_and_dice == 0.0) then
		if (energy >= 25) then
			spell = Mutilate.L["Slice and Dice"];
		else
			nextspell = Mutilate.L["Slice and Dice"];
		end
	elseif (cp >= 1) and (slice_and_dice <= 5.0) then
		if (energy >= 35) then
			spell = Mutilate.L["Envenom"];
		else
			nextspell = Mutilate.L["Envenom"];
		end
	elseif (vanish < 1) and (overkill == 0) and (Mutilatedb.SuggestVanish == true) then
		spell = Mutilate.L["Vanish"];
	elseif (cp < 4) then
		if (energy >= 55) then
			spell = Mutilate.L["Mutilate"];
		else
			nextspell = Mutilate.L["Mutilate"];
		end
	elseif (rupture <= 2.5) and (Mutilatedb.SuggestRupture == true) then
		if (rupture <= 0.5) then	
			if (energy >= 25) then
				spell = Mutilate.L["Rupture"];
			else
				nextspell = Mutilate.L["Rupture"];
			end
		else
			nextspell = Mutilate.L["Rupture"];
		end
	elseif (deadly_posion == 1) then
		if (   (    (energy >= 35) 
		        and (Mutilate.DeadlyPoisionTick <= 1.0)
		       ) 
		    or (    (Mutilatedb.MasterPoison == true)
		        and (energy >= 35)
		       )
		   ) then
			spell = Mutilate.L["Envenom"];
			nextspell = Mutilate.L["Mutilate"];
		else
			nextspell = Mutilate.L["Envenom"];
		end
	else
		if (energy >= 80) then
			spell = Mutilate.L["Mutilate"];
		else
			nextspell = Mutilate.L["Mutilate"];
		end
	end

	Mutilate.textureList["current"]:SetTexture(GetSpellTexture(spell))
	Mutilate.textureList["next"]:SetTexture(GetSpellTexture(nextspell))

	if cold_blood < 1 then
		Mutilate.textureList["last"]:SetTexture(GetSpellTexture(Mutilate.L["Cold Blood"]))
	else
		Mutilate.textureList["last"]:SetTexture(nil)
	end
	
	if tott < 1 then
		Mutilate.textureList["misc"]:SetTexture(GetSpellTexture(Mutilate.L["Tricks of the Trade"]))
	else
		Mutilate.textureList["misc"]:SetTexture(nil)
	end
	
	if (vanish < 1) and (overkill == 0) and (Mutilatedb.SuggestVanish == false) then
		Mutilate.textureList["int"]:SetTexture(GetSpellTexture(Mutilate.L["Vanish"]))
	else
		Mutilate.textureList["int"]:SetTexture(nil)
	end
		
	if spell ~= "" and spell ~= nil then
		local start, dur = GetSpellCooldown(spell)
		if dur == 0 or start == nil or dur == nil then
			Mutilate.cooldownFrame:SetAlpha(0)
		else
			Mutilate.cooldownFrame:SetAlpha(1)
			Mutilate.cooldownFrame:SetCooldown(start, dur)
		end
	end
end

function Mutilate:CreateOptionFrame()
	local panel = CreateFrame("FRAME", "MutilateOptions");
	panel.name = "Mutilate";

	local fstring1 = panel:CreateFontString("MutilateOptions_string1","OVERLAY","GameFontNormal")
	fstring1:SetText("Lock")
	fstring1:SetPoint("TOPLEFT", 10, -10)

	local checkbox1 = CreateFrame("CheckButton", "$parent_cb1", panel, "OptionsCheckButtonTemplate")
	checkbox1:SetWidth(18)
	checkbox1:SetHeight(18)
	checkbox1:SetScript("OnClick", function() Mutilate:ToggleLocked() end)
	checkbox1:SetPoint("TOPRIGHT", -10, -10)
	checkbox1:SetChecked(Mutilate:GetLocked())
	
	
	local fstring3 = panel:CreateFontString("MutilateOptions_string3","OVERLAY","GameFontNormal")
	fstring3:SetText("Suggest Vanish in Rotation")
	fstring3:SetPoint("TOPLEFT", 10, -40)
	
	local checkbox3 = CreateFrame("CheckButton", "$parent_cb3", panel, "OptionsCheckButtonTemplate")
	checkbox3:SetWidth(18)
	checkbox3:SetHeight(18)
	checkbox3:SetScript("OnClick", function() Mutilate:ToggleVanish() end)
	checkbox3:SetPoint("TOPRIGHT", -10, -40)
	checkbox3:SetChecked(Mutilate:GetVanish())	

  
  
	local fstring4 = panel:CreateFontString("MutilateOptions_string4","OVERLAY","GameFontNormal")
	fstring4:SetText("Master Poison Spec")
	fstring4:SetPoint("TOPLEFT", 10, -70)
	
	local checkbox4 = CreateFrame("CheckButton", "$parent_cb4", panel, "OptionsCheckButtonTemplate")
	checkbox4:SetWidth(18)
	checkbox4:SetHeight(18)
	checkbox4:SetScript("OnClick", function() Mutilate:TogglePoison() end)
	checkbox4:SetPoint("TOPRIGHT", -10, -70)
	checkbox4:SetChecked(Mutilate:GetPoison())



	local fstring5 = panel:CreateFontString("MutilateOptions_string5","OVERLAY","GameFontNormal")
	fstring5:SetText("Suggest Rupture in Rotation")
	fstring5:SetPoint("TOPLEFT", 10, -100)
	
	local checkbox5 = CreateFrame("CheckButton", "$parent_cb5", panel, "OptionsCheckButtonTemplate")
	checkbox3:SetWidth(18)
	checkbox3:SetHeight(18)
	checkbox3:SetScript("OnClick", function() Mutilate:ToggleRupture() end)
	checkbox3:SetPoint("TOPRIGHT", -10, -100)
	checkbox3:SetChecked(Mutilate:GetRupture())	
	
		

	local fstring2 = panel:CreateFontString("MutilateOptions_string2","OVERLAY","GameFontNormal")
	fstring2:SetText("GUI Scale")
	fstring2:SetPoint("TOPLEFT", 10, -130)

	local slider2 = CreateFrame("Slider", "$parent_sl2", panel, "OptionsSliderTemplate")
	slider2:SetMinMaxValues(.5, 1.5)
	slider2:SetValue(Mutilate:GetScale())
	slider2:SetValueStep(.05)
	slider2:SetScript("OnValueChanged", function(self) Mutilate:SetScale(self:GetValue()); getglobal(self:GetName() .. "Text"):SetText(self:GetValue())  end)
	getglobal(slider2:GetName() .. "Low"):SetText("0.5")
	getglobal(slider2:GetName() .. "High"):SetText("1.5")
	getglobal(slider2:GetName() .. "Text"):SetText(Mutilate:GetScale())
	slider2:SetPoint("TOPRIGHT", -10, -130)

	InterfaceOptions_AddCategory(panel);
end

function Mutilate:GetLocked()
	return Mutilatedb.locked
end

function Mutilate:ToggleLocked()
	if Mutilatedb.locked then
		Mutilatedb.locked = false
		Mutilate.displayFrame:SetScript("OnMouseDown", function(self) self:StartMoving() end)
		Mutilate.displayFrame:SetScript("OnMouseUp", function(self) self:StopMovingOrSizing() end)
		Mutilate.displayFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
		Mutilate.displayFrame:SetBackdropColor(0, 0, 0, .4)
		Mutilate.displayFrame:EnableMouse(true)
	else
		Mutilatedb.locked = true
		Mutilate.displayFrame:SetScript("OnMouseDown", nil)
		Mutilate.displayFrame:SetScript("OnMouseUp", nil)
		Mutilate.displayFrame:SetScript("OnDragStop", nil)
		Mutilate.displayFrame:SetBackdropColor(0, 0, 0, 0)
		Mutilate.displayFrame:EnableMouse(false)
	end
end

function Mutilate:GetScale()
	return Mutilatedb.scale
end
function Mutilate:SetScale(num)
	Mutilatedb.scale = num
	Mutilate.displayFrame:SetScale(Mutilatedb.scale)
	Mutilate.cooldownFrame:SetScale(Mutilatedb.scale)
end

function Mutilate.Options()
	InterfaceOptionsFrame_OpenToCategory(getglobal("MutilateOptions"))
end


function Mutilate:GetVanish()
	return Mutilatedb.SuggestVanish
end
	
function Mutilate:GetPoison()
	return Mutilatedb.MasterPoison
end

function Mutilate:GetRupture()
	return Mutilatedb.SuggestRupture
end

function Mutilate:TogglePoison()
	if(Mutilatedb.MasterPoison == true) then
		Mutilatedb.MasterPoison = false
	else
		Mutilatedb.MasterPoison = true
	end

end

function Mutilate:ToggleVanish()
	if(Mutilatedb.SuggestVanish == true) then
		Mutilatedb.SuggestVanish = false
	else
		Mutilatedb.SuggestVanish = true
	end
end

function Mutilate:ToggleRupture()
	if(Mutilatedb.SuggestRupture == true) then
		Mutilatedb.SuggestRupture = false
	else
		Mutilatedb.SuggestRupture = true
	end
end

